## Description:

Survivors can revive their fallen colleagues, but it comes at the price of their own health. A skull totem marks where the player died. Stand within the circle to begin, but stay at your own risk ;) <br> <br> All players need this mod

<br>

### Integration:
* Use [InLobbyConfig](https://thunderstore.io/package/KingEnderBrine/InLobbyConfig/) to configure this plugin in-game. 
* [ItemStatsMod](https://thunderstore.io/package/ontrigger/ItemStatsMod/)
* [BetterUI](https://thunderstore.io/package/XoXFaby/BetterUI/)

<br>

### Feedback

Feedback would be greatly appreciated. It you encounter a bug or want to discuss new or existing features, please submit an issue on Github, or contact KosmosisDire#4195 or amadare#8308 on Discord!

<br> <br>

## Default Game Mode:

The default and most simple game mode. When a teammate dies you can revive them by staying inside of the red bubble around where they died. Reviving drains your health over time to balance things out. This keeps you from reviving during battle, but once battle is over it isn't too dangerous to revive.

<br> <br>

## Death Curse Game Mode:

This is a new optional game mode which fleshes out the experience with more difficulty and revival mechanics. There are a number of under the hood things to make the whole system balanced and adjust to player skill.

### **Reviving**

Reviving is the same, but after you revive someone you will be linked to that player for a time. This just means that you helped revive the player, and this will effect things under the hood.

### **Death Curse**

![Death Curse Icon](https://thecodespace.ddns.net/fileshare/TeammateRevival/timed_curse.png)

When a player is revived, they will receive the **Death Curse**, along with one random other linked player. **Death Curse** is a debuff that reduces **Max HP/ Shield** simmilar to Shaped Glass. These debuffs will stack!

![Charon's Obol](https://thecodespace.ddns.net/fileshare/TeammateRevival/obol.png)

The **Charon's Obol** item makes revival faster and easier. It can also be consumed to make revival instant without getting cursed.

### **Death Curse** and **Obol**

Every time you enter a new stage, **1 Curse** will be removed. This goes up by **1** for every **Obol** you have.

<br> <br>

## Change Notes:
* 4.0.0 - big thanks to amadare
    * Huge refactoring of whole codebase
    * A lot of bug fixes and general improvements
    * The revival time now makes actual sense.
    * Added optional Death Curse mechanic and Charon's Obol that adds more depth to revive mechanic
        * Added ItemStats & BetterUI mods integration
    * Added revival progress bar
    * Changed and tweaked revival formulae
    * Network optimization
    * Every revival aspect is highly configurable
    * Revival range is now increased depending on players inside
    * Added some debugging tools
    * Trancendence used to break it, but now it's a feature ;)

* 3.3.8
    * Fixed bug that caused players to instantly respawn after their first revival.

* 3.3.7
    * Fixed stupid bug that made the whole mod do nothing and break.

* 3.3.6
    * Fixed possible incompatibility with drop in multiplayer
    * Made more reliable

* 3.3.5
    * Fixed a bug that caused skulls to not spawn - not tested but pretty sure this will fix it
    * Please submit an issue on Github if there is still a problem!

* 3.3.4
    * Fixed a bug that made the mod think the players hadn't died

* 3.3.3
    * Hopefully fixed a bug that caused a NRE on player death.

* 3.3.2
    * Now when a player dies in midair the totem / skull will spawn at the closest ground location  (rather than midair).
    * Damage numbers now show on both client and server.
    * Lighting should now also sync to the clients as well.
    * Fixed a bug where the mod didn't recognize if the player was revived by something other than this mod.

* 3.1.0
    * Works now lol
    * I actually tested it this time :P

* 3.0.0
    * Actually fixed a bug that kept it from working after the first stage
    * Fixed a TON of other networking bugs.
    * Everything should actually work now.

* 2.3.2
    * Hopefully fixed bug where it wouldn't do anything after the first stage
    * Fixed a bug where clients would run server-side code
    * Hopefully everything works decently now? sorry for so many updates all at once

* 2.2.1
    * Fixed some more networking bugs hopefully

* 2.2.0
    * Hopefully fixed networking for the most part! It was broken this whole time and I didn't realize

* 2.1.0
    * Visual Changes
        * Made range circle more visible
        * Made damage effect less visible (only shows damage numbers)
        * Shows healing numbers on the player skull
        * light now goes back to red if you leave the revival radius
    * Revival should now be quicker
    * Config items DO NOT WORK, but I can't figure out how to get rid of them without the user deleting the file
    * Players can now use up all their health down to 1HP while reviving someone.

* 2.0.0
    * Major visual update
        * A red-lit skull marks the place of death
        * An 'X' marker visible through any terrain now shows above the skull.
        * Dynamic lighting queues how close the player is to revival.
        * A circle on the ground shows the range you must stay in to continue reviving your teammate.
    * Fixed Bugs:
        * Fixed a bug that caused hundreds of Null Reference Exceptions
        * Made it so the player list is only populated once, unless new players join the game.
        * Mod must now be downloaded by each player.
    * Removed many unnecissary logs.
    * Miscelaneous changes to the system.
        

* 1.0.6
    * Made it so it actually works this time (WOW!)
    * Added a skull that hovers over a player's location on death (this is used as the revival point)
    * Made health drain from the reviving player and add onto the dead player (speed depends on player level)
    * Still lots of bugs and polish and visual changes that need to be added!

* 1.0.5
    * Hopefully fixed players being able to revive themselves
    * (I didn't fix it it broke the entire thing... yay)

* 1.0.4
    * Got mod actually working
    * Bugs:
        * Players can revive themselves after they die :|

* 1.0.3
    * fixed versioning

* 1.0.2
    * Fixed a few problems (still not functional yet)

* 1.0.1:
    * Fixed typos
    * updated artwork

* 1.0.0:
    * Initial "release" (not really a release but, eh)
    * was put on here for testing multiplayer, but accidentally started at 1.0.0 unstead of 0.0.1 :|


(Keywords: respawn - heal - bleed - steal - give - multiplayer)
